io.undertow.client

## Interface ClientExchange

All Superinterfaces:
  Attachable

All Known Implementing Classes:
  Http2ClientExchange

    public interface ClientExchange
    extends Attachable

Author:
  Stuart Douglas

### Method Summary

All Methods Instance Methods Abstract Methods
`ClientConnection` `getConnection()`
`ClientResponse` `getContinueResponse()`
`ClientRequest` `getRequest()`
`org.xnio.channels.StreamSinkChannel` `getRequestChannel()` Returns the request channel that can be used to send data to the server.
`ClientResponse` `getResponse()`
`org.xnio.channels.StreamSourceChannel` `getResponseChannel()` Returns the response channel that can be used to read data from the target server.
`void` `setContinueHandler(ContinueNotification continueHandler)`
`void` `setPushHandler(PushCallback pushCallback)`
`void` `setResponseListener(ClientCallback<ClientExchange> responseListener)`

### Methods inherited from interface io.undertow.util.Attachable

`addToAttachmentList, getAttachment, getAttachmentList, putAttachment, removeAttachment`

### Method Detail

#### setResponseListener

    void setResponseListener(ClientCallback<ClientExchange> responseListener)

#### setContinueHandler

    void setContinueHandler(ContinueNotification continueHandler)

#### setPushHandler

    void setPushHandler(PushCallback pushCallback)

#### getRequestChannel

    org.xnio.channels.StreamSinkChannel getRequestChannel()

Returns the request channel that can be used to send data to the server.

Returns:
  The request channel

#### getResponseChannel

    org.xnio.channels.StreamSourceChannel getResponseChannel()

Returns the response channel that can be used to read data from the target server.

Returns:
  The response channel

#### getRequest

    ClientRequest getRequest()

#### getResponse

    ClientResponse getResponse()

Returns:
  The client response, or null if it has not been received yet

#### getContinueResponse

    ClientResponse getContinueResponse()

Returns:
  the result of a HTTP 100-continue response

#### getConnection

    ClientConnection getConnection()

Returns:
  The underlying connection